<?php

 /* script returns icecast v2.3.1 statistical information via console or web browser
    script uses icecounter.php for xml data retrieval(is a icecounter.php frontend)
    usage: run "php ice_metter.php" for information, or "php ice_metter.php -l" for list of available statisctial info
    author: amnesiac@netzond.com
 */

 include('icecounter.php');

 function get_data($tags) {
    $timePrev=time() + microtime();

    $counter=retrieve($tags,true);

    $timeNow=time() + microtime() - $timePrev;
    $result[]=$counter;
    $result[]=$timeNow;

    return $result;
 }

 function constants($argv,$script) {
    $args=0;
    $constant_name=array('REFRESH_INTERVAL','MULTIPLIER','LIST_TAGS','TYPE');
    $constant_value=array(1,1,false,'gauge');
    $shortcut = array('-r','-m','-l','-t');

    $argv_inv=array_flip($argv);
    if ($script) {
	foreach ($shortcut as $id => $shname) if (in_array($shname,$argv)) {DEFINE ($constant_name[$id],$argv[$argv_inv[$shname]+1],true);$args++;}
    } else {
	foreach ($shortcut as $id => $shname) if (array_key_exists(substr($shname,1),$argv)) {DEFINE ($constant_name[$id],$argv[substr($shname,1)],true);$args++;}
    }
    foreach ($constant_name as $id => $cname) DEFINE($cname,$constant_value[$id],true);//DEFINE DEFAULT VALUES    
    DEFINE('ARGS',$args);
 }

 if ($_SERVER['argc']==1 && empty($_REQUEST)) die("usage: ".$_SERVER['SCRIPT_NAME']."\n -l [list tags]\n\tlists available tags\n -r [refresh interval]\n\t time interval between measurements in COUNTER* mode (default:1)\n -m [multiplier]\n\t useful when turning bytes into bits (default:1)\n -t [type]\n\t *counter - shows received data as it is\n\t gauge - shows change of data during refresh interval(useful for monitoring traffic)\n\t(default:gauge)\n PARAMETERS: \n tag1 mount1:tag7 mount2:tag3 \nEXAMPLES:\n #php ".$_SERVER['SCRIPT_NAME']." clients\n\t -displays clients connected to the server\n #php ".$_SERVER['SCRIPT_NAME']." -r 3 -t counter SKY_STATION64:total_bytes_read SKY_STATION128:total_bytes_read\n\t displays per mount traffic (bytes/sec)\nhttp://127.0.0.1/ice_metter.php?r=3&t=counter&SKY_STATIONS128:total_bytes_sent\n");
 
 if ($argv[1]=='-l') {
    print_r(retrieve('list_tags',false));die;
 } elseif ($_SERVER['argc']>=2) {
    constants(&$argv,true);
    for ($i=(ARGS*2+1); $i<$_SERVER['argc']; $i++) {
        if (stristr($argv[$i],':') == false) $tags[]=$argv[$i];
        else $tags[]=explode(":",$argv[$i]);
    }
 } elseif (count($_REQUEST)>0) {
    constants(&$_REQUEST,false);
    $i=0;
    foreach ($_REQUEST as $id => $tag) {
    if (!in_array($id,array('r','m','l','t'))) {
    	if (stristr($id,':') == false) $tags[]=$id;
    	else $tags[]=explode(":",$id);
	$i++;
    }
    }
 }

 if (TYPE=='counter') {
    $counter['prev']=get_data($tags);
	sleep(REFRESH_INTERVAL);
    $counter['curr']=get_data($tags);
 
    for ($i=0;$i<count($counter['prev'][0]);$i++) {
	$result=floor(MULTIPLIER*($counter['curr'][0][$i] - $counter['prev'][0][$i]) / ($counter['prev'][1][1]/2+$counter['curr'][1][1]/2+REFRESH_INTERVAL));
	echo $result."\n";
    }
 } else {
    retrieve($tags,false);
 }

?>
